;Add 8x* file

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN DialogBox,FunkyLine,Explorer_Error,Traverse_symTable,Explore_ListDirectory,vputstring,IPutS,IGetKey,VEraseEOL,fixVarNames
 EXTERN myLoadCIndPaged,myLoadDEIndPaged,BHL_plus_DE
 EXTERN sOK

Explore_Add:
	ld l,3
	ld h,15
	ld e,89
	ld d,47
	call DialogBox
	ld bc,3*256+24
	ld e,88
	call FunkyLine
	ld hl,16*256+6
	ld (pencol),hl
	ld hl,sAddText
	call vputstring
	ld hl,24*256+6
	ld (pencol),hl
	ld hl,sAdd1
	call vputstring
	ld hl,31*256+6
	ld (pencol),hl
	ld a,0CFh
	B_CALL VPutMap
	ld hl,31*256+84
	ld (pencol),hl
	ld a,Lconvert
	B_CALL VPutMap
	ld hl,40*256+42
	ld (pencol),hl
	ld hl,sOK
	call vputstring
	ld bc,3*256+40
	ld e,88
	call FunkyLine
	xor a
	ld (var_ptr),a
$$:
	call Traverse_symTable
	jr c,$F
	ld a,(var_ptr)
	inc a
	ld (var_ptr),a
	jr $B
$$:	ld a,(var_ptr)
	dec a
	ld (var_ptr),a
	call Traverse_symTable
Add_Display:
	ld hl,OP1
	ld de,OP3
	ld bc,10
	ldir
	ld hl,31*256+10
	ld (pencol),hl
	ld hl,OP1+1
	call fixVarNames
	ld hl,OP1+1
	call vputstring
	ld c,55
	call VEraseEOL
	ld a,60
	ld (pencol),a
	ld a,(OP1)
	inc a
	ld b,a
	ld hl,sTypeTable-6
	ld de,6
$$:
	add hl,de
	djnz $B
	call vputstring
	ld c,83
	call VEraseEOL
Add_KeyLoop:
	call IGetKey
	cp kClear
	jr z,Explore_ListDirectory
	cp kQuit
	jr z,Explore_ListDirectory
	cp kLeft
	jr z,Add_MoveLeft
	cp kRight
	jr z,Add_MoveRight
	cp kEnter
	jr z,Add_DoTheDew
	jr Add_KeyLoop
Add_MoveLeft:
	ld a,(var_ptr)
	inc a
	call Traverse_symTable
	jr c,Add_KeyLoop
	ld a,(var_ptr)
	inc a
	ld (var_ptr),a
	jr Add_Display
Add_MoveRight:
	ld a,(var_ptr)
	dec a
	call Traverse_symTable
	jr c,Add_KeyLoop
	ld a,(var_ptr)
	dec a
	ld (var_ptr),a
	jr Add_Display
Add_DoTheDew:
	ld hl,0303h
	ld (curRow),hl
	ld hl,sAdding
	call IPutS
	ld hl,OP3
	ld de,OP1
	ld bc,10
	ldir
	ld a,(OP1)
	or a
	jr z,Add_DTD_1
	cp 0Ch
	jr z,Add_DTD_1
	B_CALL ChkFindSym
       ld a,b
       or a
       jr nz,Add_Archived
	ex de,hl
	B_CALL ldhlind
       jr Add_DTD_Continue
Add_Archived:
       ex de,hl
       ld de,9
       call BHL_plus_DE
       call myLoadCIndPaged
       ld d,0
       ld e,c
       call BHL_plus_DE
       call myLoadDEIndPaged
       ex de,hl
Add_DTD_Continue:
	ld a,h
	or l
	ld a,errMSDVarEmpty
	scf
	jr z,$F
Add_DTD_1:
       ld hl,OP3
       ld de,OP1
       ld bc,10
       ldir
	ld hl,current_dir
	U_CALL MSD_ExportVariable
	push af
       U_CALL GetErrorCode
       pop af
       ld a,b
$$:	ld hl,sAddError
	jr c,Explorer_Error
	jr Explore_ListDirectory

sAddText:
	DB "ADD FILE...",0
sAdd1:
	DB "Select variable:",0
sAdding:
	DB "COPYING",0CEh,0
sAddError:
	DB "This file could",0
	DB "not be added here.",0
sTypeTable:
	DB "REAL",0,0		;0h
	DB "LIST",0,0		;1h
	DB "MATRX",0		;2h
	DB "EQU",0,0,0	;3h
	DB "STRNG",0		;4h
	DB "PRGM",0,0		;5h
	DB "PRGM",0,0		;6h
	DB "PIC",0,0,0	;7h
	DB "GDB",0,0,0	;8h
	DB 0,0,0,0,0,0	;9h
	DB 0,0,0,0,0,0	;0Ah
	DB "WIND",0,0		;0Bh
	DB "CPLX",0,0		;0Ch
	DB "LIST",0,0		;0Dh
	DB 0,0,0,0,0,0	;0Eh
	DB "WIND",0,0		;0Fh
	DB "WIND",0,0		;10h
	DB "TBLST",0		;11h
	DB 0,0,0,0,0,0	;12h
	DB 0,0,0,0,0,0	;13h (backup, not supported)
	DB 0,0,0,0,0,0	;14h
	DB "AVAR",0,0		;15h
