;Display 8XI file

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN Explorer_Error,IGetKey,fastCopy,cmpstrb,Explore_ListDirectoryStay

Explore_Disp8XI:
       ld hl,current_dir
       ld de,temp_file
$$:    ld a,(hl)
       ld (de),a
       or a
       jr z,$F
       inc hl
       inc de
       jr $B
$$:    ld a,(current_dir+1)
       or a
       jr z,$F
       ld a,'/'
       ld (de),a
       inc de
$$:    ld hl,cur_entry
       U_CALL FAT_nameConvertFrom11
       ld hl,temp_file
       ld de,temp_handle
       U_CALL DOS_openFile
       ld hl,temp_handle
       ld de,OP1
       ld bc,6
       push de
       U_CALL DOS_fileRead
       pop de
       ld hl,FileHeader
       ld b,4
       call cmpstrb
       ld a,errMSDCorruptFile
       ld hl,sCorruptError
       jr nz,Explorer_Error
       ld bc,temp_handle
       ld de,0
       ld hl,55
       U_CALL DOS_fileSeek
       ld hl,temp_handle
       ld de,OP1
       ld bc,2
       U_CALL DOS_fileRead
       ld hl,61
       ld de,(OP1)
       add hl,de
       ld bc,temp_handle
       ld de,0
       U_CALL DOS_fileSeek
       ld hl,temp_handle
       ld de,plotSScreen
       ld bc,756
       U_CALL DOS_fileRead
       ld hl,plotSScreen+(96*63)
       ld bc,12
       B_CALL MemClear
       call fastCopy
       call IGetKey
       jr Explore_ListDirectoryStay
sCorruptError:
	DB "This file appears",0
	DB "to be corrupt.",0
FileHeader:
	DB "**TI"
