;Create new folder

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN DialogBox,FunkyLine,vputstring,Explorer_Error,Explore_ListDirectory
 EXTERN sOK

Explore_New:
	ld hl,9B84h
	ld de,hook_temp+1
	ld bc,4
	ldir
	xor a
	ld (hook_temp),a
	bit 5,(iy+34h)
	jr z,$F
	inc a
	ld (hook_temp),a
$$:    ld hl,myKeyHook
	in a,(6)
	B_CALL EnRawKeyHook
	ld l,13
	ld h,15
	ld e,79
	ld d,47
	call DialogBox
	ld bc,13*256+24
	ld e,78
	call FunkyLine
	ld hl,16*256+16
	ld (pencol),hl
	ld hl,sNewText
	call vputstring
	ld hl,40*256+41
	ld (pencol),hl
	ld hl,sOK
	call vputstring
	ld hl,25*256+16
	ld (pencol),hl
	ld hl,sNewText1
	call vputstring
	ld bc,13*256+40
	ld e,78
	call FunkyLine
	ld a,3
	ld (SmallEditCancelParse),a
	ld a,20
	ld (SmallEditColumnLeft),a
	ld a,75
	ld (SmallEditColumnRight),a
	ld a,32
	ld (SmallEditRow),a
	xor a
	ld (SmallEditPromptString),a
	inc a
	ld (SmallEditRowCount),a
	B_CALL InitSmallEditLine
       set shiftAlpha,(iy+shiftFlags)
       set shiftALock,(iy+shiftFlags)
       res inRename,(iy+msd8xFlags)
	B_CALL StartSmallEdit
       push af
	res 5,(iy+34h)
	ld hl,hook_temp+1
	ld de,9B84h
	ld bc,4
	ldir
	ld a,(hook_temp)
	or a
	jr z,$F
	set 5,(iy+34h)
$$:    pop af
	cp kQuit
	jr z,Add_Ret
	ld hl,temp_file
	ld bc,10
	B_CALL MemClear
	B_CALL ChkFindSym
	ld a,(de)
	or a
	jr z,Add_Ret
	and 00001111b
	ld b,a
	inc de
	inc de
	ex de,hl
	ld de,temp_file
New_CopyLoop:
       ld a,(hl)
       cp ':'
       jr nz,$F
$$:    ld (de),a
       inc hl
       inc de
       djnz New_CopyLoop
       xor a
       ld (de),a
	B_CALL ReleaseSEdit
       ld a,(temp_file)
       cp '.'
       jr nz,$F
       xor a
       ld hl,sNewError
       jr Explorer_Error
$$:    ld hl,temp_file
       ld de,OP1
       U_CALL FAT_nameConvertTo11
       ex de,hl
       ld hl,(dir_cluster)
       U_CALL FAT_findFileInCluster
       jr c,Add_NoDuplicate
       ld a,errMSDDuplicateFound
       ld hl,sDuplicateFolder
       jr Explorer_Error
Add_NoDuplicate:
       ld de,temp_file
	ld hl,(dir_cluster)
	U_CALL DOS_createDirectory
       push af
       U_CALL GetErrorCode
       pop af
	ld a,b
	ld hl,sNewError
	jr c,Explorer_Error
	jr Add_Quit
Add_Ret:
	B_CALL ReleaseSEdit
Add_Quit:
	jr Explore_ListDirectory
myKeyHook:
	DB 83h
       ;bit inRename,(iy+msd8xFlags)
       ;jr z,$F
       ;cp kStat
       ;jr z,mkh_stat
       cp kDecPnt
       jr z,mkh_OK
$$:	cp kUp
	jr z,mkh_cancel
	cp kDown
	jr z,mkh_cancel
       cp kDel
       jr z,mkh_OK
	cp kEnter
	jr z,mkh_OK
	cp kLeft
	jr z,mkh_OK
	cp kRight
	jr z,mkh_OK
	cp kClear
	jr z,mkh_OK
	cp kQuit
	jr z,mkh_OK
	cp kSpace
	jr z,mkh_cancel
	cp kEE
	jr z,mkh_cancel
	cp k0
	jp m,mkh_cancel
	cp kCapZ+1
	jp m,mkh_OK
mkh_cancel:
	xor a
	ret
;mkh_stat:
;       ld a,60h
mkh_OK:
	or a
	ret
sNewText:
	DB "NEW FOLDER...",0
sNewText1:
	DB "Enter folder name:",0
sNewError:
	DB "This directory",0
	DB "cannot be created.",0
sDuplicateFolder:
       DB "This directory",0
       DB "already exists.",0
