;Rename file/folder

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN DialogBox,FunkyLine,vputstring,Explorer_Error,Add_Ret,Add_Quit,myKeyHook
 EXTERN sOK

Explore_Ren:
       ld hl,cur_entry
       ld de,temp_file
       U_CALL FAT_nameConvertFrom11
       ld a,(hl)
       cp '.'
       jr nz,$F
       inc hl
       ld a,(hl)
       cp '.'
       jr nz,$F
       inc hl
       ld a,(hl)
       or a
       jr nz,$F
       ld hl,sCannotRename
       xor a
       jr Explorer_Error
$$:	ld hl,9B84h
	ld de,hook_temp+1
	ld bc,4
	ldir
	xor a
	ld (hook_temp),a
	bit 5,(iy+34h)
	jr z,$F
	inc a
	ld (hook_temp),a
$$:    ld hl,myKeyHook
	in a,(6)
	B_CALL EnRawKeyHook
	ld l,13
	ld h,15
	ld e,79
	ld d,47
	call DialogBox
	ld bc,13*256+24
	ld e,78
	call FunkyLine
	ld hl,16*256+16
	ld (pencol),hl
	ld hl,sRenText
	call vputstring
	ld hl,40*256+41
	ld (pencol),hl
	ld hl,sOK
	call vputstring
	ld hl,25*256+16
	ld (pencol),hl
	ld hl,sRenText1
	call vputstring
	ld bc,13*256+40
	ld e,78
	call FunkyLine
	ld a,3
	ld (SmallEditCancelParse),a
	ld a,20
	ld (SmallEditColumnLeft),a
	ld a,75
	ld (SmallEditColumnRight),a
	ld a,32
	ld (SmallEditRow),a
	xor a
	ld (SmallEditPromptString),a
	inc a
	ld (SmallEditRowCount),a
	B_CALL InitSmallEditLine
       set shiftAlpha,(iy+shiftFlags)
       set shiftALock,(iy+shiftFlags)
       set inRename,(iy+msd8xFlags)
	B_CALL StartSmallEdit
       push af
	res 5,(iy+34h)
	ld hl,hook_temp+1
	ld de,9B84h
	ld bc,4
	ldir
	ld a,(hook_temp)
	or a
	jr z,$F
	set 5,(iy+34h)
$$:    pop af
	cp kQuit
	jr z,Add_Ret
	ld hl,temp_file
	ld bc,10
	B_CALL MemClear
	B_CALL ChkFindSym
	ld a,(de)
	or a
	jr z,Add_Ret
	and 00001111b
	ld b,a
	inc de
	inc de
	ex de,hl
	ld de,temp_handle ;used as temporary space here
Ren_CopyLoop:
       ld a,(hl)
       cp ':'
       jr nz,$F
       ld a,'.'
$$:    ld (de),a
       inc hl
       inc de
       djnz Ren_CopyLoop
       xor a
       ld (de),a
	B_CALL ReleaseSEdit
       ld a,(temp_handle)
       cp '.'
       jr nz,Ren_GoodName
       xor a
       ld hl,sRenError
       jr Explorer_Error
Ren_GoodName:
       ld hl,current_dir+1
       ld de,temp_file
       ld a,(hl)
       dec hl
       or a
       jr z,Ren_Root
$$:    ld a,(hl)
       ld (de),a
       inc hl
       inc de
       or a
       jr nz,$B
       dec de
Ren_Root:
       ld a,'/'
       ld (de),a
       inc de
       ld hl,cur_entry
       U_CALL FAT_nameConvertFrom11
       ld hl,temp_file
       ld de,temp_handle
	U_CALL DOS_renameFileEntry
       push af
       U_CALL GetErrorCode
       pop af
	ld a,b
	ld hl,sRenError
	jr c,Explorer_Error
	jr Add_Quit

sRenError:
       DB "This entry",0
       DB "was not renamed.",0
sCannotRename:
       DB "This cannot",0
       DB "be renamed.",0
sRenText:
       DB "RENAME...",0
sRenText1:
       DB "Enter new name:",0