;Copy 8x* file to RAM/archive

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN DialogBox,FunkyLine,Explore_ListDirectory,vputstring,IGetKey,fastCopy,Explorer_Error,Explore_KeyLoop
 EXTERN sOK

Explore_Copy:
	ld de,ValidTypes
	ld hl,cur_entry+8
	ld a,(hl)
	cp '8'
	jr nz,Explore_KeyLoop
	inc hl
	ld a,(hl)
	inc hl
	cp 'X'
	jr z,$F
	cp 'x'
	jr nz,Explore_KeyLoop
$$:    ld a,(de)
	cp (hl)
	jr z,$F
	or a
	jr z,Explore_KeyLoop
	inc de
	jr $B
$$:    ld l,13
	ld h,15
	ld e,79
	ld d,47
	call DialogBox
	ld bc,13*256+24
	ld e,78
	call FunkyLine
	ld hl,16*256+16
	ld (pencol),hl
	ld hl,sCopyText
	call vputstring
	ld hl,40*256+41
	ld (pencol),hl
	ld hl,sOK
	call vputstring
	ld bc,13*256+40
	ld e,78
	call FunkyLine
	xor a
	ld (bChoice),a
Copy_KeyRefresh:
	ld hl,plotSScreen
	B_CALL SaveDisp
	ld hl,plotSScreen+12*25+2
	ld b,10
	ld de,7
Copy_ClearLoop:
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	add hl,de
	djnz Copy_ClearLoop
	call fastCopy
	ld a,(bChoice)
	or a
	jr nz,Copy_RefreshFlash
	ld hl,28*256+20
	jr Copy_RefreshContinue
Copy_RefreshFlash:
	ld hl,28*256+41
Copy_RefreshContinue:
	ld (pencol),hl
	ld a,Lconvert
	B_CALL VPutMap
	ld a,24
	ld (pencol),a
	ld hl,sRAMFlash
	call vputstring
	ld a,45
	ld (pencol),a
	call vputstring
Copy_KeyLoop:
	call IGetKey
	cp kClear
	jr z,Explore_ListDirectory
	cp kQuit
	jr z,Explore_ListDirectory
	cp kEnter
	jr z,Copy_DoTheDew
	cp kLeft
	jr z,Copy_SwitchSelection
	cp kRight
	jr z,Copy_SwitchSelection
	jr Copy_KeyLoop
Copy_SwitchSelection:
	ld a,(bChoice)
	xor 1
	ld (bChoice),a
	jr Copy_KeyRefresh
Copy_DoTheDew:
	ld hl,current_dir+1
	ld de,temp_file
	ld a,(hl)
	dec hl
	or a
	jr z,Copy_DTD_1
$$:    ld a,(hl)
	or a
	jr z,Copy_DTD_1
	ld (de),a
	inc hl
	inc de
	jr $B
Copy_DTD_1:
	ld a,'/'
	ld (de),a
	inc de
	ld hl,cur_entry
	U_CALL FAT_nameConvertFrom11
	ld hl,temp_file
	ld a,(bChoice)
       sla a
       ld b,a
	U_CALL MSD_ImportVariable
       push af
       U_CALL GetErrorCode
       pop af
	ld a,b
	ld hl,sCopyError
	jr c,Explorer_Error
	jr Explore_ListDirectory

ValidTypes:
	DB "CDGILMNPSVY",0
sCopyText:
	DB "COPY FILE TO...",0
sRAMFlash:
	DB "RAM",0
	DB "Archive",0
sCopyError:
       DB "This file could",0
       DB "not be copied.",0