;Delete file/folder

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc"
 include "usb8x.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN DialogBox,FunkyLine,vputstring,IGetKey,Explore_ListDirectory,Explorer_Error,IPutS,fastCopy
 EXTERN sOK

Explore_Del:
	ld l,13
	ld h,15
	ld e,79
	ld d,47
	call DialogBox
	ld bc,13*256+24
	ld e,78
	call FunkyLine
	ld hl,16*256+16
	ld (pencol),hl
	ld hl,sSureText
	call vputstring
	ld hl,40*256+41
	ld (pencol),hl
	ld hl,sOK
	call vputstring
	ld bc,13*256+40
	ld e,78
	call FunkyLine
	ld a,1
	ld (bChoice),a
Del_KeyRefresh:
	ld hl,plotSScreen
	B_CALL SaveDisp
	ld hl,plotSScreen+12*25+2
	ld b,10
	ld de,7
Del_ClearLoop:
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	add hl,de
	djnz Del_ClearLoop
	call fastCopy
	ld a,(bChoice)
	or a
	jr nz,Del_RefreshNo
	ld hl,28*256+20
	jr Del_RefreshContinue
Del_RefreshNo:
	ld hl,28*256+56
Del_RefreshContinue:
	ld (pencol),hl
	ld a,Lconvert
	B_CALL VPutMap
	ld a,24
	ld (pencol),a
	ld hl,sYesNo
	call vputstring
	ld a,60
	ld (pencol),a
	call vputstring
Del_KeyLoop:
	call IGetKey
	cp kEnter
	jr z,Del_DoTheDew
	cp kQuit
	jr z,Explore_ListDirectory
	cp kClear
	jr z,Explore_ListDirectory
	cp kLeft
	jr z,Del_SwitchSelection
	cp kRight
	jr z,Del_SwitchSelection
	jr Del_KeyLoop
Del_DoTheDew:
	ld a,(bChoice)
	or a
	jr nz,Explore_ListDirectory
	ld de,cur_entry
	ld a,(de)
	cp '.'
	jr nz,Del_DTD_Continue
	inc de
	ld a,(de)
	cp '.'
	ld a,errMSDNotValidPath
	ld hl,sDelError
	jr z,Explorer_Error
Del_DTD_Continue:
	ld hl,0303h
	ld (curRow),hl
	ld hl,sDeleting
	call IPutS
	ld de,cur_entry
	ld hl,(dir_cluster)
	U_CALL DOS_deleteFileEntry
       push af
       U_CALL GetErrorCode
       pop af
	ld a,b
	ld hl,sDelError
	jr c,Explorer_Error
	jr Explore_ListDirectory
Del_SwitchSelection:
	ld a,(bChoice)
	xor 1
	ld (bChoice),a
	jr Del_KeyRefresh
sSureText:
	DB "ARE YOU SURE?",0
sYesNo:
	DB "Yes",0
	DB "No",0
sDelError:
	DB "This entry cannot",0
	DB "be deleted.",0
sDeleting:
	DB "DELETING",0CEh,0
